import { world } from "@minecraft/server";
import {
    ActionFormData,
    MessageFormData,
    ModalFormData
} from "@minecraft/server-ui";
var undoHolder = [];
var count = 0;

world.afterEvents.playerPlaceBlock.subscribe((event) => {
    const player = event.player; // Player that place the block
    const block = event.block; // Block that's placed

    if(block.typeId === "pa:constructor"){
        form.show(player).then(async r => {
            // This will stop the code when the player closes the form
            if (r.canceled) return;
            let response = r.selection;
            let x = event.block.x;
            let y = event.block.y;
            let z = event.block.z;
            player.runCommandAsync(`setblock ${x} ${y} ${z} air`);
    switch (response) {
                case 0:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~49 0 ~32`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 5397fc1f-ff3f-44a8-aa81-42e97725f1ed${count} ${x+0} ${y} ${z+0} ${x+48} ${y+105} ${z+31}`);

        allUndoCommand.push({
          "name":`5397fc1f-ff3f-44a8-aa81-42e97725f1ed${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 5397fc1f-ff3f-44a8-aa81-42e97725f1ed ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 1:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~35 0 ~32`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 0b039b40-7f4c-42ac-9ac4-1040d6ae0999${count} ${x+0} ${y} ${z+0} ${x+34} ${y+101} ${z+31}`);

        allUndoCommand.push({
          "name":`0b039b40-7f4c-42ac-9ac4-1040d6ae0999${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 0b039b40-7f4c-42ac-9ac4-1040d6ae0999 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 2:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~64 0 ~64`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save a437c0bc-a77b-480d-a272-d9cabad3039d${count} ${x+0} ${y} ${z+0} ${x+63} ${y+100} ${z+63}`);

        allUndoCommand.push({
          "name":`a437c0bc-a77b-480d-a272-d9cabad3039d${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load a437c0bc-a77b-480d-a272-d9cabad3039d ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 3:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~48 0 ~48`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save b1a6cb40-8911-49b9-8328-7dbd2abd1484${count} ${x+0} ${y} ${z+0} ${x+47} ${y+100} ${z+47}`);

        allUndoCommand.push({
          "name":`b1a6cb40-8911-49b9-8328-7dbd2abd1484${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load b1a6cb40-8911-49b9-8328-7dbd2abd1484 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 4:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~35 0 ~33`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 78104bdc-0ed2-45f1-9a40-47ad22da4b1e${count} ${x+0} ${y} ${z+0} ${x+34} ${y+100} ${z+32}`);

        allUndoCommand.push({
          "name":`78104bdc-0ed2-45f1-9a40-47ad22da4b1e${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 78104bdc-0ed2-45f1-9a40-47ad22da4b1e ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 5:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~64 0 ~64`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save fb6f6191-c8f1-4b5a-acaa-630f3fa8c769${count} ${x+0} ${y} ${z+0} ${x+63} ${y+100} ${z+63}`);

        allUndoCommand.push({
          "name":`fb6f6191-c8f1-4b5a-acaa-630f3fa8c769${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load fb6f6191-c8f1-4b5a-acaa-630f3fa8c769 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 6:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~36 0 ~49`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 813425d3-b2d6-465a-bece-5e5db267326c${count} ${x+0} ${y} ${z+0} ${x+35} ${y+100} ${z+48}`);

        allUndoCommand.push({
          "name":`813425d3-b2d6-465a-bece-5e5db267326c${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 813425d3-b2d6-465a-bece-5e5db267326c ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 7:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~32 0 ~33`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 8c224e13-ea06-4e36-be17-d377b39981bf${count} ${x+0} ${y} ${z+0} ${x+31} ${y+100} ${z+32}`);

        allUndoCommand.push({
          "name":`8c224e13-ea06-4e36-be17-d377b39981bf${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 8c224e13-ea06-4e36-be17-d377b39981bf ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 8:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~31 0 ~17`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save ae011283-cd06-4e00-ac1d-f6f60c02364e${count} ${x+0} ${y} ${z+0} ${x+30} ${y+100} ${z+16}`);

        allUndoCommand.push({
          "name":`ae011283-cd06-4e00-ac1d-f6f60c02364e${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load ae011283-cd06-4e00-ac1d-f6f60c02364e ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 9:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~33 0 ~33`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 5112cbfd-b2c1-4536-b0ca-f07bbb84b4a8${count} ${x+0} ${y} ${z+0} ${x+32} ${y+100} ${z+32}`);

        allUndoCommand.push({
          "name":`5112cbfd-b2c1-4536-b0ca-f07bbb84b4a8${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 5112cbfd-b2c1-4536-b0ca-f07bbb84b4a8 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 10:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~40 0 ~40`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save dc972102-1bff-4b7e-816c-cdaef8b5e6eb${count} ${x+0} ${y} ${z+0} ${x+39} ${y+100} ${z+39}`);

        allUndoCommand.push({
          "name":`dc972102-1bff-4b7e-816c-cdaef8b5e6eb${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load dc972102-1bff-4b7e-816c-cdaef8b5e6eb ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 11:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~64 0 ~64`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 5868f3a4-01d2-4782-8281-37da9593432b${count} ${x+0} ${y} ${z+0} ${x+63} ${y+100} ${z+63}`);

        allUndoCommand.push({
          "name":`5868f3a4-01d2-4782-8281-37da9593432b${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 5868f3a4-01d2-4782-8281-37da9593432b ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 12:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~32 0 ~32`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 7fccc716-f36d-4a15-b5ed-fb1ca392730c${count} ${x+0} ${y} ${z+0} ${x+31} ${y+100} ${z+31}`);

        allUndoCommand.push({
          "name":`7fccc716-f36d-4a15-b5ed-fb1ca392730c${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 7fccc716-f36d-4a15-b5ed-fb1ca392730c ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 13:
                   if(undoHolder.length > 0){
                            var data = undoHolder.pop();
                        for(var i = 0; i < data.data.length; i++){
                            let structureName = data.data[i].name;
                            let x = data.data[i].x;
                            let y = data.data[i].y;
                            let z = data.data[i].z;
                            world.sendMessage(`Undo Structure ${structureName} at ${x} ${y} ${z}`)
                            await player.runCommandAsync(`tickingarea add ${x} 0 ${z} ${x} 0 ${z}`);
                            await player.runCommandAsync(`structure load ${structureName} ${x} ${y} ${z}`).then(()=>{
                            player.runCommandAsync(`structure delete ${structureName}`);
                            });
                        }
                            await player.runCommandAsync(`tickingarea remove_all`);
                         }else{
                            player.sendMessage("You have nothing to undo");
                         }
                    break;
                        
                default:
                // Use this when your button doesn't have a function yet
                // You don't need to use "break" on default case
                // Remember to place the default on very bottom
            }
        });;
    }
})
///Form dialog
let form = new ActionFormData()
    .title("Build Structure")
    .body("Choose the structure")
.button("mtile4", "textures/arts/5397fc1f-ff3f-44a8-aa81-42e97725f1ed")
.button("mtile3", "textures/arts/0b039b40-7f4c-42ac-9ac4-1040d6ae0999")
.button("mtile2", "textures/arts/a437c0bc-a77b-480d-a272-d9cabad3039d")
.button("mtile1", "textures/arts/b1a6cb40-8911-49b9-8328-7dbd2abd1484")
.button("mtile7", "textures/arts/78104bdc-0ed2-45f1-9a40-47ad22da4b1e")
.button("mtile6f", "textures/arts/fb6f6191-c8f1-4b5a-acaa-630f3fa8c769")
.button("mtile5", "textures/arts/813425d3-b2d6-465a-bece-5e5db267326c")
.button("b2m", "textures/arts/8c224e13-ea06-4e36-be17-d377b39981bf")
.button("b1m", "textures/arts/ae011283-cd06-4e00-ac1d-f6f60c02364e")
.button("tile4m", "textures/arts/5112cbfd-b2c1-4536-b0ca-f07bbb84b4a8")
.button("tile3m", "textures/arts/dc972102-1bff-4b7e-816c-cdaef8b5e6eb")
.button("tile2m", "textures/arts/5868f3a4-01d2-4782-8281-37da9593432b")
.button("tile1m", "textures/arts/7fccc716-f36d-4a15-b5ed-fb1ca392730c")
    .button("Undo", "textures/items/barrier");
    